setup.py 17.5 KB
Newer Older
1
#!/usr/bin/env python3
2

3
# Copyright 2011-2015 Kwant authors.
4
#
Christoph Groth's avatar
Christoph Groth committed
5
6
# This file is part of Kwant.  It is subject to the license terms in the file
# LICENSE.rst found in the top-level directory of this distribution and at
7
# http://kwant-project.org/license.  A list of Kwant authors can be found in
Christoph Groth's avatar
Christoph Groth committed
8
# the file AUTHORS.rst at the top-level directory of this distribution and at
9
10
# http://kwant-project.org/authors.

11
from __future__ import print_function
Christoph Groth's avatar
Christoph Groth committed
12
13

import sys
14
15

v = sys.version_info
16
17
18
19
if v[:2] < (3, 4):
    error = "This version of Kwant requires Python 3.4 or above.\n"
    if v[0] == 2:
        error += "Kwant 1.1 is the last version to support Python 2."
20
21
22
    print(error, file=sys.stderr)
    sys.exit(1)

23
import re
Christoph Groth's avatar
Christoph Groth committed
24
import os
25
import glob
26
import imp
Christoph Groth's avatar
Christoph Groth committed
27
import subprocess
28
import configparser
29
from setuptools import setup, find_packages, Extension, Command
Christoph Groth's avatar
Christoph Groth committed
30
from sysconfig import get_platform
Christoph Groth's avatar
Christoph Groth committed
31
32
from distutils.errors import DistutilsError, DistutilsModuleError, \
    CCompilerError
33
from distutils.command.build import build
Christoph Groth's avatar
Christoph Groth committed
34
35
from setuptools.command.sdist import sdist
from setuptools.command.build_ext import build_ext
36

37
38
39
40
41
42
try:
    import numpy
except ImportError:
    include_dirs = []
else:
    include_dirs = [numpy.get_include()]
Christoph Groth's avatar
Christoph Groth committed
43

44
45
CONFIG_FILE = 'build.conf'
README_FILE = 'README.rst'
Christoph Groth's avatar
Christoph Groth committed
46
MANIFEST_IN_FILE = 'MANIFEST.in'
47
README_END_BEFORE = 'See also in this directory:'
48
STATIC_VERSION_PATH = ('kwant', '_kwant_version.py')
Christoph Groth's avatar
Christoph Groth committed
49
REQUIRED_CYTHON_VERSION = (0, 22)
50
CYTHON_OPTION = '--cython'
51
CYTHON_TRACE_OPTION = '--cython-trace'
52
53
54
TUT_DIR = 'tutorial'
TUT_GLOB = 'doc/source/tutorial/*.py'
TUT_HIDDEN_PREFIX = '#HIDDEN'
Joseph Weston's avatar
Joseph Weston committed
55
CLASSIFIERS = """\
56
    Development Status :: 5 - Production/Stable
Joseph Weston's avatar
Joseph Weston committed
57
58
59
60
61
62
63
64
65
66
    Intended Audience :: Science/Research
    Intended Audience :: Developers
    Programming Language :: Python :: 3 :: Only
    Topic :: Software Development
    Topic :: Scientific/Engineering
    Operating System :: POSIX
    Operating System :: Unix
    Operating System :: MacOS :: MacOS X
    Operating System :: Microsoft :: Windows"""

67

68
69
70
71
72
73
74
75
76
77
# Let Kwant itself determine its own version.  We cannot simply import kwant, as
# it is not built yet.
_dont_write_bytecode_saved = sys.dont_write_bytecode
sys.dont_write_bytecode = True
_common = imp.load_source('_common', 'kwant/_common.py')
sys.dont_write_bytecode = _dont_write_bytecode_saved

version = _common.version
version_is_from_git = _common.version_is_from_git

Christoph Groth's avatar
Christoph Groth committed
78
try:
79
    sys.argv.remove(CYTHON_OPTION)
80
    use_cython = True
81
except ValueError:
82
    use_cython = version_is_from_git
Christoph Groth's avatar
Christoph Groth committed
83

84
85
86
87
88
89
90
91
92
93
try:
    sys.argv.remove(CYTHON_TRACE_OPTION)
    trace_cython = True
    if not use_cython:
        print('error: --cython-trace provided, but cython will not be run',
              file=sys.stderr)
        exit(1)
except ValueError:
    trace_cython = False

94
if use_cython:
95
96
    try:
        import Cython
97
98
        from Cython.Build import cythonize
    except ImportError:
99
100
101
102
103
104
105
106
107
108
109
        cython_version = ()
    else:
        match = re.match('([0-9.]*)(.*)', Cython.__version__)
        cython_version = [int(n) for n in match.group(1).split('.')]
        # Decrease version if the version string contains a suffix.
        if match.group(2):
            while cython_version[-1] == 0:
                cython_version.pop()
            cython_version[-1] -= 1
        cython_version = tuple(cython_version)

110
distr_root = os.path.dirname(os.path.abspath(__file__))
111

112
113
114
def banner(title=''):
    starred = title.center(79, '*')
    return '\n' + starred if title else starred
115

116
error_msg = """{header}
117
118
119
The compilation of Kwant has failed.  Please examine the error message
above and consult the installation instructions in README.rst.
You might have to customize {{file}}.
120

121
Build configuration was:
122

123
{{summary}}
124
125
126
{sep}
"""
error_msg = error_msg.format(header=banner(' Error '), sep=banner())
Christoph Groth's avatar
Christoph Groth committed
127

Christoph Groth's avatar
Christoph Groth committed
128

Christoph Groth's avatar
Christoph Groth committed
129
130
class kwant_build_ext(build_ext):
    def run(self):
131
132
133
134
135
136
137
138
        if not config_file_present:
            # Create an empty config file if none is present so that the
            # extensions will not be rebuilt each time.  Only depending on the
            # config file if it is present would make it impossible to detect a
            # necessary rebuild due to a deleted config file.
            with open(CONFIG_FILE, 'w') as f:
                f.write('# Created by setup.py - feel free to modify.\n')

Christoph Groth's avatar
Christoph Groth committed
139
140
141
        try:
            build_ext.run(self)
        except (DistutilsError, CCompilerError):
142
143
            print(error_msg.format(file=CONFIG_FILE, summary=build_summary),
                  file=sys.stderr)
Christoph Groth's avatar
Christoph Groth committed
144
            raise
145
        print(banner(' Build summary '))
146
        print(build_summary)
147
        print(banner())
Christoph Groth's avatar
Christoph Groth committed
148

149

150
class kwant_build_tut(Command):
151
152
153
154
155
156
157
158
159
160
161
162
163
164
    description = "build the tutorial scripts"
    user_options = []

    def initialize_options(self):
        pass

    def finalize_options(self):
        pass

    def run(self):
        if not os.path.exists(TUT_DIR):
            os.mkdir(TUT_DIR)
        for in_fname in glob.glob(TUT_GLOB):
            out_fname = os.path.join(TUT_DIR, os.path.basename(in_fname))
165
166
167
168
169
            with open(in_fname) as in_file:
                with open(out_fname, 'w') as out_file:
                    for line in in_file:
                        if not line.startswith(TUT_HIDDEN_PREFIX):
                            out_file.write(line)
170
171
172
173
174
175


# Our version of the "build" command also makes sure the tutorial is made.
# Even though the tutorial is not necessary for installation, and "build" is
# supposed to make everything needed to install, this is a robust way to ensure
# that the tutorial is present.
176
177
class kwant_build(build):
    sub_commands = [('build_tut', None)] + build.sub_commands
178

179
    def run(self):
180
        build.run(self)
181
182
        write_version(os.path.join(self.build_lib, *STATIC_VERSION_PATH))

183
184

def git_lsfiles():
185
    if not version_is_from_git:
186
187
        return

188
    try:
189
        p = subprocess.Popen(['git', 'ls-files'], cwd=distr_root,
190
191
192
193
194
195
                             stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    except OSError:
        return

    if p.wait() != 0:
        return
Joseph Weston's avatar
Joseph Weston committed
196
    return p.communicate()[0].decode().split('\n')[:-1]
197
198


199
200
201
202
# Make the command "sdist" depend on "build".  This verifies that the
# distribution in the current state actually builds.  It also makes sure that
# the Cython-made C files and the tutorial will be included in the source
# distribution and that they will be up-to-date.
203
204
class kwant_sdist(sdist):
    sub_commands = [('build', None)] + sdist.sub_commands
205
206

    def run(self):
Christoph Groth's avatar
Christoph Groth committed
207
208
209
210
211
212
213
214
215
216
        """
        Create MANIFEST.in from git if possible, otherwise check that MANIFEST.in
        is present.

        Right now (2015) generating MANIFEST.in seems to be the only way to
        include files in the source distribution that setuptools does not think
        should be there.  Setting include_package_data to True makes setuptools
        include *.pyx and other source files in the binary distribution.
        """
        manifest = os.path.join(distr_root, MANIFEST_IN_FILE)
217
218
        names = git_lsfiles()
        if names is None:
Christoph Groth's avatar
Christoph Groth committed
219
220
221
222
            if not (os.path.isfile(manifest) and os.access(manifest, os.R_OK)):
                print("Error:", MANIFEST_IN_FILE,
                      "file is missing and Git is not available"
                      " to regenerate it.", file=sys.stderr)
223
224
                exit(1)
        else:
Christoph Groth's avatar
Christoph Groth committed
225
            with open(manifest, 'w') as f:
226
227
228
229
230
                for name in names:
                    a, sep, b = name.rpartition('/')
                    if b == '.gitignore':
                        continue
                    stem, dot, extension = b.rpartition('.')
Christoph Groth's avatar
Christoph Groth committed
231
                    f.write('include {}'.format(name))
232
                    if extension == 'pyx':
Christoph Groth's avatar
Christoph Groth committed
233
234
                        f.write(''.join([' ', a, sep, stem, dot, 'c']))
                    f.write('\n')
235

236
        sdist.run(self)
237
238

        if names is None:
239
            print(banner(' Caution '),
Christoph Groth's avatar
Christoph Groth committed
240
        """Git was not available to generate the list of files to be included in the
241
242
source distribution.  The old {} was used.""".format(MANIFEST_IN_FILE),
                  banner(), sep='\n', file=sys.stderr)
243

244
    def make_release_tree(self, base_dir, files):
245
        sdist.make_release_tree(self, base_dir, files)
246
        write_version(os.path.join(base_dir, *STATIC_VERSION_PATH))
247

Christoph Groth's avatar
Christoph Groth committed
248

249
250
251
def write_version(fname):
    # This could be a hard link, so try to delete it first.  Is there any way
    # to do this atomically together with opening?
252
    try:
253
254
255
256
257
        os.remove(fname)
    except OSError:
        pass
    with open(fname, 'w') as f:
        f.write("# This file has been created by setup.py.\n")
Christoph Groth's avatar
Christoph Groth committed
258
        f.write("version = '{}'\n".format(version))
Christoph Groth's avatar
Christoph Groth committed
259
260


261
262
263
264
265
def long_description():
    text = []
    try:
        with open(README_FILE) as f:
            for line in f:
266
                if line.startswith(README_END_BEFORE):
267
268
                    break
                text.append(line.rstrip())
269
270
            while text[-1] == "":
                text.pop()
271
272
273
274
275
    except:
        return ''
    return '\n'.join(text)


276
277
278
279
280
281
282
283
284
285
286
287
def search_mumps():
    """Return the configuration for MUMPS if it is available in a known way.

    This is known to work with the MUMPS provided by the Debian package
    libmumps-scotch-dev."""

    libs = ['zmumps_scotch', 'mumps_common_scotch', 'pord', 'mpiseq_scotch',
            'gfortran']

    cmd = ['gcc']
    cmd.extend(['-l' + lib for lib in libs])
    cmd.extend(['-o/dev/null', '-xc', '-'])
Christoph Groth's avatar
Christoph Groth committed
288
    try:
289
        p = subprocess.Popen(cmd, stdin=subprocess.PIPE, stderr=subprocess.PIPE)
Christoph Groth's avatar
Christoph Groth committed
290
291
292
    except OSError:
        pass
    else:
293
        p.communicate(input=b'int main() {}\n')
294
295
        if p.wait() == 0:
            return {'libraries': libs}
Christoph Groth's avatar
Christoph Groth committed
296
297
298
299
    return {}


def extensions():
Christoph Groth's avatar
Christoph Groth committed
300
    """Return a list of tuples (args, kwrds) to be passed to Extension."""
Christoph Groth's avatar
Christoph Groth committed
301

302
    global build_summary, config_file_present
Christoph Groth's avatar
Christoph Groth committed
303
304
    build_summary = []

305
    #### Add components of Kwant without external compile-time dependencies.
Christoph Groth's avatar
Christoph Groth committed
306
307
308
    result = [
        (['kwant._system', ['kwant/_system.pyx']],
         {'include_dirs': ['kwant/graph']}),
Joseph Weston's avatar
Joseph Weston committed
309
310
        (['kwant.operator', ['kwant/operator.pyx']],
         {'include_dirs': ['kwant/graph']}),
Christoph Groth's avatar
Christoph Groth committed
311
312
313
314
315
316
317
318
319
320
321
322
323
324
325
326
327
        (['kwant.graph.core', ['kwant/graph/core.pyx']],
         {'depends': ['kwant/graph/core.pxd', 'kwant/graph/defs.h',
                      'kwant/graph/defs.pxd']}),
        (['kwant.graph.utils', ['kwant/graph/utils.pyx']],
         {'depends': ['kwant/graph/defs.h', 'kwant/graph/defs.pxd',
                      'kwant/graph/core.pxd']}),
        (['kwant.graph.slicer', ['kwant/graph/slicer.pyx',
                                 'kwant/graph/c_slicer/partitioner.cc',
                                 'kwant/graph/c_slicer/slicer.cc']],
         {'depends': ['kwant/graph/defs.h', 'kwant/graph/defs.pxd',
                      'kwant/graph/core.pxd',
                      'kwant/graph/c_slicer.pxd',
                      'kwant/graph/c_slicer/bucket_list.h',
                      'kwant/graph/c_slicer/graphwrap.h',
                      'kwant/graph/c_slicer/partitioner.h',
                      'kwant/graph/c_slicer/slicer.h']})]

328
329
330
331
332
333
334
    #### Add cython tracing macro
    if trace_cython:
        for args, kwargs in result:
            macros = kwargs.get('define_macros', [])
            macros.append(('CYTHON_TRACE', '1'))
            kwargs['define_macros'] = macros

335
    #### Add components of Kwant with external compile-time dependencies.
336
    config = configparser.ConfigParser()
Christoph Groth's avatar
Christoph Groth committed
337
338
    try:
        with open(CONFIG_FILE) as f:
339
            config.read_file(f)
Christoph Groth's avatar
Christoph Groth committed
340
    except IOError:
341
342
343
        config_file_present = False
    else:
        config_file_present = True
Christoph Groth's avatar
Christoph Groth committed
344
345
346
347
348
349
350
351
352
353
354
355
356
357
358
359
360
361
362
363
364
365
366
367
368

    kwrds_by_section = {}
    for section in config.sections():
        kwrds_by_section[section] = kwrds = {}
        for name, value in config.items(section):
            kwrds[name] = value.split()

    # Setup LAPACK.
    lapack = kwrds_by_section.get('lapack')
    if lapack:
        build_summary.append('User-configured LAPACK and BLAS')
    else:
        lapack = {'libraries': ['lapack', 'blas']}
        build_summary.append('Default LAPACK and BLAS')
    kwrds = lapack.copy()
    kwrds.setdefault('depends', []).extend(
        [CONFIG_FILE, 'kwant/linalg/f_lapack.pxd'])
    result.append((['kwant.linalg.lapack', ['kwant/linalg/lapack.pyx']],
                   kwrds))

    # Setup MUMPS.
    kwrds = kwrds_by_section.get('mumps')
    if kwrds:
        build_summary.append('User-configured MUMPS')
    else:
369
        kwrds = search_mumps()
Christoph Groth's avatar
Christoph Groth committed
370
        if kwrds:
371
            build_summary.append('Auto-configured MUMPS')
Christoph Groth's avatar
Christoph Groth committed
372
    if kwrds:
373
        for name, value in lapack.items():
Christoph Groth's avatar
Christoph Groth committed
374
375
376
377
378
379
380
381
382
383
384
385
            kwrds.setdefault(name, []).extend(value)
        kwrds.setdefault('depends', []).extend(
            [CONFIG_FILE, 'kwant/linalg/cmumps.pxd'])
        result.append((['kwant.linalg._mumps', ['kwant/linalg/_mumps.pyx']],
                       kwrds))
    else:
        build_summary.append('No MUMPS support')

    build_summary = '\n'.join(build_summary)
    return result


386
def complain_cython_unavailable():
387
388
    assert not use_cython or cython_version < REQUIRED_CYTHON_VERSION
    if use_cython:
389
390
        msg = ("Install Cython {0} or newer so it can be made\n"
               "or use a source distribution of Kwant.")
391
        ver = '.'.join(str(e) for e in REQUIRED_CYTHON_VERSION)
392
        print(msg.format(ver), file=sys.stderr)
393
    else:
394
        print("Run setup.py with the {} option.".format(CYTHON_OPTION),
395
              file=sys.stderr)
396
397


Christoph Groth's avatar
Christoph Groth committed
398
def ext_modules(extensions):
399
400
401
402
403
    """Prepare the ext_modules argument for setuptools.

    If Cython is not to be run, replace .pyx extensions with .c or .cpp, and
    check timestamps.
    """
404
405
    if use_cython and cython_version >= REQUIRED_CYTHON_VERSION:
        return cythonize([Extension(*args, **kwrds)
406
                          for args, kwrds in extensions], language_level=3,
Christoph Groth's avatar
Christoph Groth committed
407
                         compiler_directives={'linetrace': trace_cython})
408
409
410
411

    # Cython is not going to be run: replace pyx extension by that of
    # the shipped translated file.

Christoph Groth's avatar
Christoph Groth committed
412
    result = []
413
    problematic_files = []
Christoph Groth's avatar
Christoph Groth committed
414
    for args, kwrds in extensions:
415
416
        name, sources = args

417
418
419
420
421
422
423
424
425
426
427
428
429
430
431
432
433
434
435
436
437
438
439
440
441
442
443
444
445
446
447
448
449
450
451
452
453
454
455
        language = kwrds.get('language')
        if language is None:
            ext = '.c'
        elif language == 'c':
            ext = '.c'
        elif language == 'c++':
            ext = '.cpp'
        else:
            print('Unknown language: {}'.format(language), file=sys.stderr)
            exit(1)

        pyx_files = []
        cythonized_files = []
        new_sources = []
        for f in sources:
            if f.endswith('.pyx'):
                pyx_files.append(f)
                f = f.rstrip('.pyx') + ext
                cythonized_files.append(f)
            new_sources.append(f)
        sources = new_sources

        # Complain if cythonized files are older than Cython source files.
        try:
            cythonized_oldest = min(os.stat(f).st_mtime
                                    for f in cythonized_files)
        except OSError:
            print("error: Cython-generated file {} is missing.".format(f),
                  file=sys.stderr)
            complain_cython_unavailable()
            exit(1)

        for f in pyx_files + kwrds.get('depends', []):
            if f == CONFIG_FILE:
                # The config file is only a dependency for the compilation
                # of the cythonized file, not for the cythonization.
                continue
            if os.stat(f).st_mtime > cythonized_oldest:
                problematic_files.append(f)
Christoph Groth's avatar
Christoph Groth committed
456

457
        result.append(Extension(name, sources, **kwrds))
Christoph Groth's avatar
Christoph Groth committed
458

459
460
461
    if problematic_files:
        problematic_files = ", ".join(problematic_files)
        msg = ("Some Cython source files are newer than files that should have\n"
462
               "been derived from them, but {}.\n"
463
464
               "\n"
               "Affected files: {}")
465
        if use_cython:
466
467
468
469
470
471
472
473
474
475
            if not cython_version:
                reason = "Cython is not installed"
            else:
                reason = "the installed Cython is too old"
            print(banner(" Error "), msg.format(reason, problematic_files),
                  banner(), sep="\n", file=sys.stderr)
            print()
            complain_cython_unavailable()
            exit(1)
        else:
476
477
478
479
480
            reason = "the option {} has not been given".format(CYTHON_OPTION)
            dontworry = ('(Do not worry about this if you are building Kwant\n'
                         'from unmodified sources, e.g. with "pip install".)\n')
            print(banner(" Caution "), dontworry,
                  msg.format(reason, problematic_files),
481
482
                  banner(), sep='\n', file=sys.stderr)

Christoph Groth's avatar
Christoph Groth committed
483
484
    return result

485

Christoph Groth's avatar
Christoph Groth committed
486
487
def main():
    setup(name='kwant',
488
          version=version,
489
490
          author='C. W. Groth (CEA), M. Wimmer, '
                 'A. R. Akhmerov, X. Waintal (CEA), and others',
491
          author_email='authors@kwant-project.org',
492
          description=("Package for numerical quantum transport calculations "
493
                       "(Python 3 version)"),
494
495
          long_description=long_description(),
          platforms=["Unix", "Linux", "Mac OS-X", "Windows"],
496
497
          url="http://kwant-project.org/",
          license="BSD",
498
          packages=find_packages('.'),
499
          cmdclass={'build': kwant_build,
500
                    'sdist': kwant_sdist,
501
                    'build_ext': kwant_build_ext,
Christoph Groth's avatar
Christoph Groth committed
502
                    'build_tut': kwant_build_tut},
Christoph Groth's avatar
Christoph Groth committed
503
          ext_modules=ext_modules(extensions()),
504
          include_dirs=include_dirs,
Anton Akhmerov's avatar
Anton Akhmerov committed
505
506
          setup_requires=['numpy > 1.6.1', 'pytest-runner >= 2.7'],
          tests_require=['pytest >= 2.6.3'],
Christoph Groth's avatar
Christoph Groth committed
507
          install_requires=['numpy > 1.6.1', 'scipy >= 0.9', 'tinyarray'],
Joseph Weston's avatar
Joseph Weston committed
508
509
          extras_require={'plotting': 'matplotlib >= 1.2'},
          classifiers=[c.strip() for c in CLASSIFIERS.split('\n')])
510

Christoph Groth's avatar
Christoph Groth committed
511
512
if __name__ == '__main__':
    main()